
## Getting Started
- ##### Clone the project
- ##### Install the Dependencies
```bash
$ npm i
```
- ##### Run the Webpack
```bash
$ npm run build
```
- ##### Run the express server
```bash
$ npm run server
```
- ##### To run the webpack-dev-server
```bash
$ npm run client:dev
```



## Look for the `config/index.js` for making changes in the configs of the project
- Edit the src/client/index.js to make changes for client

- Edit the src/components to make changes in components

- Edit the src/server/index.js to make changes in the server



## technology
- NodeJS - Server
- ExpressJS - Nodejs framework
- MongoDB - Database
- ReactJS - Frontend
- Redux - State Management
- Docker - Containerization and image
- Eslint - Linter
- Webpack - Bundler
- Babel - Loader and Compiler/Transpiler
- Jest - Testing Framework


## Features
- [x] Server Side Rendering
- [x] State Management
- [x] Image for Container
- [x] Routing
- [x] Model Controller Project Structure
- [ ] Build Pipelines
- [ ] Tests
- [ ] Examples



